using System;
using System.Drawing;
using MonoTouch.Foundation;
using MonoTouch.UIKit;

namespace BlogPost_NSCoding_Monotouch
{
	public partial class BlogPost_NSCoding_MonotouchViewController : UIViewController
	{
		UIButton _saveData;
		UIButton _loadData;

		UIButton _saveDataToFile;
		UIButton _loadDataFromFile;

		UILabel _label1;
		UILabel _label2;

		NSData _savedData;

		static bool UserInterfaceIdiomIsPhone {
			get { return UIDevice.CurrentDevice.UserInterfaceIdiom == UIUserInterfaceIdiom.Phone; }
		}

		public BlogPost_NSCoding_MonotouchViewController ()
			: base (UserInterfaceIdiomIsPhone ? "BlogPost_NSCoding_MonotouchViewController_iPhone" : "BlogPost_NSCoding_MonotouchViewController_iPad", null)
		{
		}

		public override void DidReceiveMemoryWarning ()
		{
			// Releases the view if it doesn't have a superview.
			base.DidReceiveMemoryWarning ();
			
			// Release any cached data, images, etc that aren't in use.
		}

		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			
			// Perform any additional setup after loading the view, typically from a nib.

			_saveData = new UIButton ();
			_saveData.Frame = new RectangleF (0, 40, 100, 100);
			_saveData.BackgroundColor = UIColor.Yellow;
			UILabel label = new UILabel(new RectangleF(0, 0, 100, 100));
			label.BackgroundColor = UIColor.Clear;
			label.Text = @"Save Data - Memory";
			label.Lines = 0;
			_saveData.AddSubview(label);
			this.View.AddSubview(_saveData);
			UITapGestureRecognizer tap1 = new  UITapGestureRecognizer(this, new MonoTouch.ObjCRuntime.Selector ("tapToSave"));
			_saveData.AddGestureRecognizer(tap1);

			_loadData = new UIButton ();
			_loadData.Frame = new RectangleF (100, 40, 100, 100);
			_loadData.BackgroundColor = UIColor.Green;

			label = new UILabel(new RectangleF(0, 0, 100, 100));
			label.BackgroundColor = UIColor.Clear;
			label.Lines = 0;
			label.Text = @"Load Data - Memory";
			_loadData.AddSubview(label);
			this.View.AddSubview(_loadData);
			UITapGestureRecognizer tap2 = new  UITapGestureRecognizer(this,new MonoTouch.ObjCRuntime.Selector("tapToLoad"));
			_loadData.AddGestureRecognizer(tap2);

			_saveDataToFile =  new UIButton ();
			_saveDataToFile.Frame = new RectangleF	(0, 150, 100, 100);
			_saveDataToFile.BackgroundColor = UIColor.Yellow;

			label = new UILabel(new RectangleF(0, 0, 100, 100));
			label.BackgroundColor = UIColor.Clear;
			label.Text = @"Save Data - File";
			label.Lines = 0;
			_saveDataToFile .AddSubview(label);
			this.View.AddSubview(_saveDataToFile);
			UITapGestureRecognizer tap3 = new  UITapGestureRecognizer(this,new MonoTouch.ObjCRuntime.Selector ("tapToSave2"));
			_saveDataToFile.AddGestureRecognizer(tap3);

			_loadDataFromFile =  new UIButton ();
			_loadDataFromFile.Frame = new RectangleF (100, 150, 100, 100);
			_loadDataFromFile.BackgroundColor = UIColor.Green;

			label = new UILabel(new RectangleF(0, 0, 100, 100));
			label.BackgroundColor = UIColor.Clear;
			label.Lines = 0;
			label.Text = @"Load Data - File";
			_loadDataFromFile.AddSubview(label);

			this.View.AddSubview(_loadDataFromFile);
			UITapGestureRecognizer tap4 = new  UITapGestureRecognizer(this,new MonoTouch.ObjCRuntime.Selector ("tapToLoad2"));
			_loadDataFromFile.AddGestureRecognizer(tap4);

			_label1 = new UILabel (new RectangleF (200, 40, 100, 100));
			this.View.AddSubview (_label1);
			_label2 = new UILabel (new RectangleF (200, 150, 100, 100));
			this.View.AddSubview (_label2);
		}

		public override bool ShouldAutorotateToInterfaceOrientation (UIInterfaceOrientation toInterfaceOrientation)
		{
			// Return true for supported orientations
			if (UserInterfaceIdiomIsPhone) {
				return (toInterfaceOrientation != UIInterfaceOrientation.PortraitUpsideDown);
			} else {
				return true;
			}
		}


		NSMutableArray makeData()
		{
			NSMutableArray data = new NSMutableArray();

			Book b1 = new Book ();
			b1.Title = @"Book 1";
			b1.PageCount = 10;
			b1.Publisher = new Publisher(@"First Publisher");

			Book b2 = new Book ();
			b2.Title = @"Book 2";
			b2.PageCount = 20;
			b2.Publisher =  new Publisher(@"Second Publisher");

			Book b3 = new Book ();

			data.Add(b1);
			data.Add(b2);
			data.Add(b3);

			return data;
		}

		[Export("tapToSave")]
		 void tapToSave()
		{
			_savedData = NSKeyedArchiver.ArchivedDataWithRootObject(this.makeData());
			_label1.Text = "Saved";
		}

		[Export("tapToLoad")]
		void tapToLoad()
		{
			if (_savedData != null)
			{
				NSMutableArray bookData = (NSMutableArray)NSKeyedUnarchiver.UnarchiveObject (_savedData);
				_label1.Text = bookData.Count.ToString();
			}
			_savedData = null;
		}

		[Export("tapToSave2")]
		void tapToSave2()
		{
			this.save(@"MyFile",this.makeData());
			_label2.Text = "Saved";
		}

		void ensureDiretory(string path)
		{
			NSFileManager manager = NSFileManager.DefaultManager;
			if(! manager.FileExists(path))
			{
				manager.CreateDirectory (path, true, null);
			}
		}

		void save(string key,NSObject data)
		{
			NSKeyedArchiver.ArchiveRootObjectToFile(data,pathToFile(key).ToString());
		}

		NSObject load(string key)
		{
			return (NSMutableArray)NSKeyedUnarchiver.UnarchiveFile(this.pathToFile(key));
		}

		NSString pathToFile(string key)
		{
			string[] paths =   NSSearchPath.GetDirectories(NSSearchPathDirectory.LibraryDirectory ,NSSearchPathDomain.User, true);
			string rootPath = paths[0];
			NSString rootPathAsNSString = new NSString (rootPath);

			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString("DataStorage"));

			this. ensureDiretory(rootPathAsNSString.ToString());

			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString(key));
			rootPathAsNSString = rootPathAsNSString.AppendPathExtension (new NSString("data"));

			return rootPathAsNSString;
		}

		[Export("tapToLoad2")]
		void tapToLoad2()
		{
			NSMutableArray arr = (NSMutableArray) this.load (@"MyFile");
			_label2.Text = arr.Count.ToString ();
		}
	}
}

