using System;
using System.Drawing;
using MonoTouch.Foundation;
using MonoTouch.UIKit;

namespace BlogPost_NSCoding_Monotouch
{

	public class Book : NSObject
	{
		public int PageCount {
			get;
			set;
		}
		public string Title {
			get;
			set;
		}
		public Publisher Publisher {
			get;
			set;
		}

		public Book ()
		{
		}
		[Export("initWithCoder:")]
		public Book(NSCoder coder)
		{
			this.PageCount = coder.DecodeInt (@"pageCount");

			NSString str =  (NSString)coder.DecodeObject (@"title");
			if (str != null) {
				this.Title = str.ToString ();
			}
		
			this.Publisher = (Publisher) coder.DecodeObject ("publisher");
		}

		public override void EncodeTo (NSCoder coder)
		{
			if (this.Title != null)
				coder.Encode (new NSString (this.Title), "title");

			coder.Encode (this.PageCount, "pageCount");
			if(this.Publisher!=null)
				coder.Encode (this.Publisher, "publisher");
		}
	}

	public class Publisher : NSObject
	{
		public string Name{
			get;
			set;
		}
		public Publisher ()
		{
		}

		[Export("initWithCoder:")]
		public Publisher(NSCoder coder)
		{
			NSString str =  (NSString)coder.DecodeObject (@"name");
			if (str != null)
				this.Name = str.ToString ();
		}

		public Publisher(string name)
		{
			this.Name = name;
		}
		public override void EncodeTo (NSCoder coder)
		{
			if (this.Name!=null)
				coder.Encode ( new NSString( this.Name), "name");
		}
	}
}